<?php
$codigobanco                        = "033";
$codigo_banco_com_dv                = geraCodigoBanco($codigobanco);
$nummoeda                           = "9";
$fixo                               = "9";
$ios                                = "0";
$fator_vencimento                   = fator_vencimento($dadosboleto["data_vencimento"]);
$valor                              = formata_numero($dadosboleto["valor_boleto"],10,0,"valor");
$carteira                           = $dadosboleto["carteira"];
$codigocliente                      = formata_numero($dadosboleto["codigo_cliente"],7,0);
$nnum                               = formata_numero($dadosboleto["nosso_numero"],7,0);
$dv_nosso_numero                    = modulo_11($nnum,9,0);
$nossonumero                        = $nnum.$dv_nosso_numero;
$vencimento                         = $dadosboleto["data_vencimento"];
$vencjuliano                        = dataJuliano($vencimento);
$barra                              = "$codigobanco$nummoeda$fator_vencimento$valor$fixo$codigocliente$nossonumero$ios$carteira";
$dv                                 = digitoVerificador_barra($barra);
$linha                              = substr($barra,0,4) . $dv . substr($barra,4);
$dadosboleto["codigo_barras"]       = $linha;
$dadosboleto["linha_digitavel"]     = monta_linha_digitavel($linha);
$dadosboleto["nosso_numero"]        = $nossonumero;
$dadosboleto["codigo_banco_com_dv"] = $codigo_banco_com_dv;


function dataJuliano($data)
{
	$dia = (int)substr($data,1,2);
	$mes = (int)substr($data,3,2);
	$ano = (int)substr($data,6,4);
	$dataf = strtotime("$ano/$mes/$dia");
	$datai = strtotime(($ano-1).'/12/31');
	$dias  = (int)(($dataf - $datai)/(60*60*24));
  return str_pad($dias,3,'0',STR_PAD_LEFT).substr($data,9,4);
}

function digitoVerificador_nossonumero($numero) {
	$resto2 = modulo_11($numero, 9, 1);
     $digito = 11 - $resto2;
     if ($digito == 10 || $digito == 11) {
        $dv = 0;
     } else {
        $dv = $digito;
     }
	 return $dv;
}


function digitoVerificador_barra($numero) {
	$resto2 = modulo_11($numero, 9, 1);
     if ($resto2 == 0 || $resto2 == 1 || $resto2 == 10) {
        $dv = 1;
     } else {
	 	$dv = 11 - $resto2;
     }
	 return $dv;
}


function formata_numero($numero,$loop,$insert,$tipo = "geral") {
	if ($tipo == "geral") {
		$numero = str_replace(",","",$numero);
		while(strlen($numero)<$loop){
			$numero = $insert . $numero;
		}
	}
	if ($tipo == "valor") {
		$numero = str_replace(",","",$numero);
		while(strlen($numero)<$loop){
			$numero = $insert . $numero;
		}
	}
	if ($tipo == "convenio") {
		while(strlen($numero)<$loop){
			$numero = $numero . $insert;
		}
	}
	return $numero;
}


function fbarcode($valor){

	require_once(DIR_SYSTEM . 'startup.php');

	$registry = new Registry();
	$config = new Config();
	$registry->set('config', $config);

$fino = 1 ;
$largo = 3 ;
$altura = 50 ;

  $barcodes[0] = "00110" ;
  $barcodes[1] = "10001" ;
  $barcodes[2] = "01001" ;
  $barcodes[3] = "11000" ;
  $barcodes[4] = "00101" ;
  $barcodes[5] = "10100" ;
  $barcodes[6] = "01100" ;
  $barcodes[7] = "00011" ;
  $barcodes[8] = "10010" ;
  $barcodes[9] = "01010" ;
  for($f1=9;$f1>=0;$f1--){
    for($f2=9;$f2>=0;$f2--){
      $f = ($f1 * 10) + $f2 ;
      $texto = "" ;
      for($i=1;$i<6;$i++){
        $texto .=  substr($barcodes[$f1],($i-1),1) . substr($barcodes[$f2],($i-1),1);
      }
      $barcodes[$f] = $texto;
    }
  }


?>
<img src=<?php echo $config->get('config_url'); ?>boleto/imagens/p.png width=<?php echo $fino?> height=<?php echo $altura?> border=0>
<img src=<?php echo $config->get('config_url'); ?>boleto/imagens/b.png width=<?php echo $fino?> height=<?php echo $altura?> border=0>
<img src=<?php echo $config->get('config_url'); ?>boleto/imagens/p.png width=<?php echo $fino?> height=<?php echo $altura?> border=0>
<img src=<?php echo $config->get('config_url'); ?>boleto/imagens/b.png width=<?php echo $fino?> height=<?php echo $altura?> border=0>
<img
<?php
$texto = $valor ;
if((strlen($texto) % 2) <> 0){
	$texto = "0" . $texto;
}

while (strlen($texto) > 0) {
  $i = round(esquerda($texto,2));
  $texto = direita($texto,strlen($texto)-2);
  $f = $barcodes[$i];
  for($i=1;$i<11;$i+=2){
    if (substr($f,($i-1),1) == "0") {
      $f1 = $fino ;
    }else{
      $f1 = $largo ;
    }
?>
    src=<?php echo $config->get('config_url');?>boleto/imagens/p.png width=<?php echo $f1?> height=<?php echo $altura?> border=0><img
<?php
    if (substr($f,$i,1) == "0") {
      $f2 = $fino ;
    }else{
      $f2 = $largo ;
    }
?>
    src=<?php echo $config->get('config_url');?>boleto/imagens/b.png width=<?php echo $f2?> height=<?php echo $altura?> border=0><img
<?php
  }
}

?>
src=<?php echo $config->get('config_url');?>boleto/imagens/p.png width=<?php echo $largo?> height=<?php echo $altura?> border=0><img
src=<?php echo $config->get('config_url');?>boleto/imagens/b.png width=<?php echo $fino?> height=<?php echo $altura?> border=0><img
src=<?php echo $config->get('config_url');?>boleto/imagens/p.png width=<?php echo 1?> height=<?php echo $altura?> border=0>
  <?php
}

function esquerda($entra,$comp){
	return substr($entra,0,$comp);
}

function direita($entra,$comp){
	return substr($entra,strlen($entra)-$comp,$comp);
}

function fator_vencimento($data) {
	$data = explode("/",$data);
	$ano = $data[2];
	$mes = $data[1];
	$dia = $data[0];
    return(abs((_dateToDays("1997","10","07")) - (_dateToDays($ano, $mes, $dia))));
}

function _dateToDays($year,$month,$day) {
    $century = substr($year, 0, 2);
    $year = substr($year, 2, 2);
    if ($month > 2) {
        $month -= 3;
    } else {
        $month += 9;
        if ($year) {
            $year--;
        } else {
            $year = 99;
            $century --;
        }
    }
    return ( floor((  146097 * $century)    /  4 ) +
            floor(( 1461 * $year)        /  4 ) +
            floor(( 153 * $month +  2) /  5 ) +
                $day +  1721119);
}

function modulo_10($num) {
		$numtotal10 = 0;
        $fator = 2;

        for ($i = strlen($num); $i > 0; $i--) {
            $numeros[$i] = substr($num,$i-1,1);
            $temp = $numeros[$i] * $fator;
            $temp0=0;
            foreach (preg_split('//',$temp,-1,PREG_SPLIT_NO_EMPTY) as $k=>$v){ $temp0+=$v; }
            $parcial10[$i] = $temp0;
            $numtotal10 += $parcial10[$i];
            if ($fator == 2) {
                $fator = 1;
            } else {
                $fator = 2;
            }
        }
        $resto = $numtotal10 % 10;
        $digito = 10 - $resto;
        if ($resto == 0) {
            $digito = 0;
        }

        return $digito;

}

function modulo_11($num, $base=9, $r=0)  {

    $soma = 0;
    $fator = 2;

    for ($i = strlen($num); $i > 0; $i--) {
        $numeros[$i] = substr($num,$i-1,1);
        $parcial[$i] = $numeros[$i] * $fator;
        $soma += $parcial[$i];
        if ($fator == $base) {
            $fator = 1;
        }
        $fator++;
    }

    if ($r == 0) {
        $soma *= 10;
        $digito = $soma % 11;
        if ($digito == 10) {
            $digito = 0;
        }
        return $digito;
    } elseif ($r == 1){
        $resto = $soma % 11;
        return $resto;
    }
}

function modulo_11_invertido($num)
{
   $ftini = 2;
   $fator = $ftfim = 9;
   $soma = 0;

   for ($i = strlen($num); $i > 0; $i--)
   {
      $soma += substr($num,$i-1,1) * $fator;
	  if(--$fator < $ftini)
	     $fator = $ftfim;
    }

    $digito = $soma % 11;

	if($digito > 9)
	   $digito = 0;

	return $digito;
}

function monta_linha_digitavel($codigo)
{
    $campo1 = substr($codigo,0,3) . substr($codigo,3,1) . substr($codigo,19,1) . substr($codigo,20,4);
	$campo1 = $campo1 . modulo_10($campo1);
    $campo1 = substr($campo1, 0, 5).'.'.substr($campo1, 5);
	$campo2 = substr($codigo,24,10);
	$campo2 = $campo2 . modulo_10($campo2);
    $campo2 = substr($campo2, 0, 5).'.'.substr($campo2, 5);
	$campo3 = substr($codigo,34,10);
	$campo3 = $campo3 . modulo_10($campo3);
    $campo3 = substr($campo3, 0, 5).'.'.substr($campo3, 5);
	$campo4 = substr($codigo, 4, 1);
	$campo5 = substr($codigo, 5, 4) . substr($codigo, 9, 10);
	return "$campo1 $campo2 $campo3 $campo4 $campo5";
}

function geraCodigoBanco($numero) {
    $parte1 = substr($numero, 0, 3);
    $parte2 = modulo_11($parte1);
    return $parte1 . "-" . $parte2;
}
